<script setup lang="ts">
import { computed, nextTick, onMounted, ref } from 'vue'
import type { Member } from '@/types/Member'
import type { VForm } from 'vuetify/components'

const initialMember: Member = {
  id: -1,
  name: '',
  tel: ''
}

function initialize() {
  members.value = [
    { id: 1, name: 'Pachari Pinijnan', tel: '088-123-4567' },
    { id: 2, name: 'Nipit Laoarun', tel: '088-765-4321' },
    { id: 3, name: 'Kwanchanok Rassameedech', tel: '092-223-5334' },
    { id: 4, name: 'Thiraya Tantakarun', tel: '087-634-0420' },
    { id: 5, name: 'Paktima Mongkolpakdee', tel: '082-211-2755' },
    { id: 6, name: 'Amporn Suwanpiti', tel: '089-280-1703' },
    { id: 7, name: 'Piyarom Weerakittana', tel: '068-195-9538' },
    { id: 8, name: 'Piwara Supannapakin', tel: '083-141-9745' },
    { id: 9, name: 'Suriyon Jirawanitch', tel: '086-860-6068' },
    { id: 10, name: 'Plathorn Weerakittana', tel: '098-951-2845' }
  ]
}

onMounted(() => {
  initialize()
})

const editedMember = ref<Member>(JSON.parse(JSON.stringify(initialMember)))
const search = ref('')
const members = ref<Member[]>([])
let editedIndex = -1
let lastId = 11
const itemsPerPage = ref<any>(5)
const page = ref(1)
const pageCount = computed(() => {
  return Math.ceil(members.value.length / itemsPerPage.value)
})
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  { title: '', key: 'actions', sortable: false }
]

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initialMember)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return

  if (editedIndex > -1) {
    const formattedNumber = `${editedMember.value.tel.slice(0, 3)}-${editedMember.value.tel.slice(3, 6)}-${editedMember.value.tel.slice(6, 10)}`;
    editedMember.value.tel = formattedNumber
    Object.assign(members.value[editedIndex], editedMember.value)
  } else {
    editedMember.value.id = lastId++
    const formattedNumber = `${editedMember.value.tel.slice(0, 3)}-${editedMember.value.tel.slice(3, 6)}-${editedMember.value.tel.slice(6, 10)}`;
    editedMember.value.tel = formattedNumber
    members.value.push(editedMember.value)
  }

  closeDialog()
}

function onSubmit() { }

function editItem(item: Member) {
  editedIndex = members.value.findIndex((p) => p.id === item.id)
  editedMember.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Member) {
  editedIndex = members.value.findIndex((p) => p.id === item.id)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  members.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initialMember)
    editedIndex = -1
  })
}

const formattedMembers = computed(() => members.value.map((Member) => ({ ...Member })))

const filteredMembers = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedMembers.value.filter((Member: any) =>
    Member.name.toLowerCase().includes(searchLower)
  )
})
</script>

<template>
  <div>
    <div class="ml-5">
      <div>
        <div class="text-center">
          <h1 style="text-align: left">MEMBER</h1>
        </div>
      </div>

      <!-- Data -->
      <div>
        <!-- new employee -->
        <div>
          <v-dialog v-model="dialog" activator="parent" width="500px" persistent>
            <template v-slot:activator="{ props }">
              <div>
                <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
                  <v-icon end icon="mdi-account" size="25px" class="mr-2"></v-icon>
                  <div style="text-align: left">New Member</div>
                </v-btn>
              </div>
            </template>
            <v-card title="Member Profile" class="pt-6" style="text-align: center">
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-col>
                      <v-text-field v-model="editedMember.name" :readonly="loading" :rules="[(v) => !!v || 'required']"
                        class="mb-2" clearable label="Full Name" variant="outlined"></v-text-field>
                    </v-col>
                    <v-col>
                      <v-text-field v-model="editedMember.tel" :readonly="loading" :rules="[
                        (v) => !/[^0-9]/g.test(v),
                        (v) => (v && v.length === 10) || 'Tel. number must be 10 digits',
                        (v) => /^\d+$/.test(v) || 'Tel. number must contain only digits'
                      ]" class="mb-2" clearable label="Tel." variant="outlined"></v-text-field>
                    </v-col>
                  </v-container>
                </v-form>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn style="width: 150px; height: 50px" variant="flat" @click="closeDialog" class="ms-auto"
                  color="red">Cancel</v-btn>
                <v-btn style="width: 150px; height: 50px" variant="flat" @click="save" class="ms-10"
                  color="success">Save</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="font ma-4 pt-6" style="text-align: center">you want to delete this info?
                🗑️</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                  @click="closeDelete">Cancel</v-btn>
                <v-spacer></v-spacer>
                <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                  @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </div>
        <!--title-->
        <v-card-title class="d-flex align-center pe-2">
          <v-icon icon="mdi-account"></v-icon> &nbsp; Member Info
          <v-spacer></v-spacer>

          <!-- search -->
          <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line
            flat hide-details variant="solo-filled"></v-text-field>
        </v-card-title>

        <!-- table -->
        <div>
          <v-data-table v-model:page="page" :headers="headers" :items="filteredMembers" :items-per-page="itemsPerPage">
            <template v-slot:bottom>
              <div class="text-center pt-2">
                <v-pagination v-model="page" :length="pageCount"></v-pagination>
              </div>
            </template>

            <!-- <template v-slot:item.actions="{ item }"> -->
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
              <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
            </template>
          </v-data-table>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: Verdana, sans-serif;
}

div {
  font-family: 'Kanit';
}
</style>
